## libpdb-redo 1.0.2

=== debian/changelog ===
libpdb-redo (1.0.2-2) unstable; urgency=medium

  * Added version numbers to the build-dependencies libzeep and libcifpp
  * Increased tolerance for unit-test to work around i386 failure

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 13:00:54 +0100

libpdb-redo (1.0.2-1) unstable; urgency=medium

  * New upstream version (includes patch from 1.0.1-2)
  * Fixes pkg-config problem for cross-building
    Closes: #978057

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 04 Jan 2021 08:35:24 +0100

libpdb-redo (1.0.1-2) unstable; urgency=medium

  * Fix for missing check in bondmap

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 15 Dec 2020 21:02:30 +0100

libpdb-redo (1.0.1-1) unstable; urgency=medium

  * Updated again with the right upstream code, but this time with a new tag

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Dec 2020 16:01:18 +0100

libpdb-redo (1.0.0-2) unstable; urgency=medium

  * Updated with the right upstream code

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 14 Dec 2020 14:09:01 +0100

libpdb-redo (1.0.0-1) unstable; urgency=medium

  * Initial release (Closes: #976727)

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Mon, 07 Dec 2020 10:50:19 +0100
