## libpdb-redo 2.0.3

=== debian/changelog ===
libpdb-redo (2.0.3-1build1) jammy; urgency=medium

  * No-change rebuild against libcifpp2

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 04 Feb 2022 22:34:58 +0000

libpdb-redo (2.0.3-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 03 Feb 2022 11:29:02 +0100

libpdb-redo (2.0.2-1) unstable; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 03 Feb 2022 10:07:32 +0100

libpdb-redo (2.0.1-3) unstable; urgency=medium

  * Transition, Closes: #1004798

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Feb 2022 08:58:20 +0100

libpdb-redo (2.0.1-2) experimental; urgency=medium

  * Set correct dependency for libcifpp

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 19 Jan 2022 13:06:22 +0100

libpdb-redo (2.0.1-1) experimental; urgency=medium

  [ Andrius Merkys ]
  * Team upload.

  [ Maarten L. Hekkelman ]
  * New upstream release

 -- Andrius Merkys <merkys@debian.org>  Tue, 09 Nov 2021 02:35:39 -0500

libpdb-redo (1.0.2-3) unstable; urgency=medium

  * Update dependency to libzeep, libcifpp

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 02 Nov 2021 07:35:14 +0100
