=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 2.0.4),
 cmake,
 libnewuoa-dev,
 pkg-config,
 libgsl-dev,
 libboost-dev,
 libboost-iostreams-dev,
 libzeep-dev (>= 5.1.7),
 libclipper-dev,
 zlib1g-dev,
 libbz2-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo2 (= ${binary:Version}),
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo2
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp2,
 libnewuoa0
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.
