=== debian/changelog ===
libpdb-redo (3.0.5-2) unstable; urgency=medium

  * Fix libcifpp dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 03 Feb 2023 09:22:45 +0100

libpdb-redo (3.0.5-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 02 Feb 2023 10:34:38 +0100

libpdb-redo (3.0.4-3) unstable; urgency=medium

  * Fix dependency on newuoa to 0.1.2-1.
  * Closes: #1025778

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sat, 07 Jan 2023 14:47:28 +0100

libpdb-redo (3.0.4-2) unstable; urgency=medium

  * Into unstable.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 30 Dec 2022 09:12:03 +0100

libpdb-redo (3.0.4-1) experimental; urgency=medium

  * New upstream release.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 23 Nov 2022 14:08:29 +0100
