=== debian/control ===
Source: libpdb-redo
Section: libs
Priority: optional
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
Build-Depends:
 debhelper-compat (= 13),
 libcifpp-dev (>= 5.0.7),
 cmake,
 libnewuoa-dev (>= 0.1.2),
 pkg-config,
 libgsl-dev,
 libboost-dev,
 libboost-regex-dev,
 libclipper-dev,
 zlib1g-dev,
 libccp4-dev (>= 6.5.1-5)
Standards-Version: 4.5.1
Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
Vcs-Git: https://salsa.debian.org/med-team/libpdb-redo.git
Homepage: https://github.com/PDB-REDO/libpdb-redo
Rules-Requires-Root: no

Package: libpdb-redo-dev
Section: libdevel
Architecture: any
Depends:
 libpdb-redo3 (= ${binary:Version}),
 libboost-regex-dev,
 libnewuoa-dev,
 libclipper-dev,
 zlib1g-dev,
 libgsl-dev,
 libcifpp-dev,
 ${misc:Depends},
Description: Development files for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This specific package contains all files needed to develop new
 software using libpdb-redo.

Package: libpdb-redo3
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
 libcifpp5,
 libnewuoa0
Description: Library file for libpdb-redo
 This library contains shared code for the various programs
 in the project PDB-REDO.
 .
 This package contains the shared library for libpdb-redo.
