## libpdb-redo 3.1.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,12 +25,9 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(pdb-redo VERSION 3.0.5 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.1.5 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
-
-# Unit tests
-option(ENABLE_TESTING "Build test exectuables" OFF)
 
 include(GNUInstallDirs)
 include(CheckFunctionExists)
@@ -39,9 +36,10 @@
 include(CMakePackageConfigHelpers)
 include(CheckCXXSourceCompiles)
 include(GenerateExportHeader)
+include(CTest)
 
 set(CXX_EXTENSIONS OFF)
-set(CMAKE_CXX_STANDARD 17)
+set(CMAKE_CXX_STANDARD 20)
 set(CMAKE_CXX_STANDARD_REQUIRED ON)
 
 if("${CMAKE_CXX_COMPILER_ID}" STREQUAL "GNU")
@@ -59,9 +57,8 @@
 # Optionally build a version to be installed inside CCP4
 option(BUILD_FOR_CCP4 "Build a version to be installed in CCP4" OFF)
 
-
-# Unit tests
-option(ENABLE_TESTING "Build test exectuables" OFF)
+# Optionally leave out the minimizer
+option(BUILD_MINIMIZER "Build the minimizer code" ON)
 
 if(BUILD_FOR_CCP4)
 	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
@@ -78,7 +75,6 @@
 	endif("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
 endif()
 
-
 # Check if CCP4 is available
 if(EXISTS "$ENV{CCP4}")
 	set(CCP4 $ENV{CCP4})
@@ -92,6 +88,7 @@
 if(MSVC)
 	# make msvc standards compliant...
 	add_compile_options(/permissive-)
+	add_link_options(/NODEFAULTLIB:library)
 
 	macro(get_WIN32_WINNT version)
 		if(WIN32 AND CMAKE_SYSTEM_VERSION)
@@ -108,21 +105,24 @@
 endif()
 
 # Libraries
+find_package(Eigen3 REQUIRED)
 find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
+
+if(BUILD_MINIMIZER)
+	find_package(GSL REQUIRED)
+endif()
 
 if(NOT PDB_REDO_META)
 	find_package(newuoa REQUIRED)
-	find_package(cifpp 5.0.4 REQUIRED)
-endif()
-
-find_package(GSL REQUIRED)
+	find_package(cifpp 7.0.6 REQUIRED)
+endif()
 
 # Create a revision file, containing the current git version info
 include(VersionString)
-write_version_header("${PROJECT_SOURCE_DIR}/src" "LibPDBREDO")
+write_version_header("${PROJECT_SOURCE_DIR}/src" LIB_NAME "LibPDBREDO")
 
 # Sources
-set(project_sources
+list(APPEND project_sources
 	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
 	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
 	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
@@ -133,12 +133,11 @@
 	${PROJECT_SOURCE_DIR}/src/ResolutionCalculator.cpp
 	${PROJECT_SOURCE_DIR}/src/SkipList.cpp
 	${PROJECT_SOURCE_DIR}/src/Statistics.cpp
-	${PROJECT_SOURCE_DIR}/src/Symmetry-2.cpp
-	${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
-	${PROJECT_SOURCE_DIR}/src/Restraints.cpp
-)
-
-set(project_headers
+	${PROJECT_SOURCE_DIR}/src/TLS.cpp
+	${PROJECT_SOURCE_DIR}/src/Version.cpp
+)
+
+list(APPEND project_headers
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
@@ -149,22 +148,38 @@
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ResolutionCalculator.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/SkipList.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/Statistics.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Symmetry-2.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
-	${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
-)
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/TLS.hpp
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/Version.hpp
+)
+
+if(BUILD_MINIMIZER)
+	list(APPEND project_sources
+		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
+		${PROJECT_SOURCE_DIR}/src/Restraints.cpp
+	)
+
+	list(APPEND project_headers
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
+	)
+endif()
 
 add_library(pdb-redo ${project_sources} ${project_headers})
 add_library(pdb-redo::pdb-redo ALIAS pdb-redo)
 set_target_properties(pdb-redo PROPERTIES POSITION_INDEPENDENT_CODE ON)
-generate_export_header(pdb-redo EXPORT_FILE_NAME pdb-redo/exports.hpp)
+generate_export_header(pdb-redo EXPORT_FILE_NAME ${PROJECT_SOURCE_DIR}/include/pdb-redo/exports.hpp)
 
 target_include_directories(pdb-redo
 	PUBLIC
-	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include;${PROJECT_BINARY_DIR}>"
+	"$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/include>"
 	"$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>"
 	${CCP4_INCLUDE_DIRS})
-target_link_libraries(pdb-redo PUBLIC cifpp::cifpp newuoa::newuoa ${CCP4_LIBRARIES} ${GSL_LIBRARIES})
+target_link_libraries(pdb-redo PUBLIC cifpp::cifpp newuoa::newuoa ${CCP4_LIBRARIES})
+target_include_directories(pdb-redo PRIVATE ${EIGEN3_INCLUDE_DIR})
+
+if(BUILD_MINIMIZER)
+	target_link_libraries(pdb-redo PUBLIC GSL::gsl)
+endif()
 
 if(CMAKE_CXX_COMPILER_ID STREQUAL "AppleClang")
 	target_link_options(pdb-redo PRIVATE -undefined dynamic_lookup)
@@ -193,11 +208,9 @@
 	COMPONENT Devel
 )
 
-install(
-	FILES ${PROJECT_BINARY_DIR}/pdb-redo/exports.hpp
-	DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/pdb-redo/
-	COMPONENT Devel
-)
+if(BUILD_MINIMIZER)
+	set(FIND_DEPENDENCY_GSL "find_dependency(GSL REQUIRED)")
+endif()
 
 configure_package_config_file(${PROJECT_SOURCE_DIR}/cmake/pdb-redoConfig.cmake.in
 	${CMAKE_CURRENT_BINARY_DIR}/pdb-redo/pdb-redoConfig.cmake
@@ -212,11 +225,10 @@
 	COMPONENT Devel
 )
 
-set(pdb-redo_MAJOR_VERSION ${CMAKE_PROJECT_VERSION_MAJOR})
 set_target_properties(pdb-redo PROPERTIES
 	VERSION ${PROJECT_VERSION}
-	SOVERSION ${pdb-redo_MAJOR_VERSION}
-	INTERFACE_pdb-redo_MAJOR_VERSION ${pdb-redo_MAJOR_VERSION})
+	SOVERSION "${PROJECT_VERSION_MAJOR}.${PROJECT_VERSION_MINOR}"
+	INTERFACE_pdb-redo_MAJOR_VERSION ${PROJECT_VERSION_MAJOR})
 
 set_property(TARGET pdb-redo APPEND PROPERTY
 	COMPATIBLE_INTERFACE_STRING pdb-redo_MAJOR_VERSION
@@ -240,10 +252,13 @@
 	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
-if(ENABLE_TESTING)
-	enable_testing()
-
-	list(APPEND PDB_REDO_tests pdb-redo-unit rsr)
+if(BUILD_TESTING AND NOT MSVC)
+	add_subdirectory(examples)
+
+	list(APPEND PDB_REDO_tests pdb-redo-unit)
+	if(BUILD_MINIMIZER)
+		list(APPEND PDB_REDO_tests rsr)
+	endif()
 
 	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
 		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
