=== debian/changelog ===
libpdb-redo (3.1.5-5) unstable; urgency=medium

  * Remove incorrect dependency, Closes: #1086519

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Thu, 31 Oct 2024 23:10:45 +0100

libpdb-redo (3.1.5-4) unstable; urgency=medium

  * Closes: #1046388, #1085426

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 29 Oct 2024 07:33:57 +0100

libpdb-redo (3.1.5-2) unstable; urgency=medium

  * Create a new upload.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 14:36:33 +0200

libpdb-redo (3.1.5-1) unstable; urgency=medium

  * New upstream 

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 14:11:00 +0200

libpdb-redo (3.1.3-2) unstable; urgency=medium

  * Update libcifpp dependency.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 25 Oct 2024 11:36:18 +0200

libpdb-redo (3.1.3-1) unstable; urgency=medium

  * New upstream.

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Fri, 18 Oct 2024 09:41:32 +0200
