=== debian/control ===
--- 
+++ 
@@ -5,13 +5,14 @@
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends:
  debhelper-compat (= 13),
- libcifpp-dev (>= 5.0.7),
+ libcifpp-dev (>= 7),
  cmake,
  libnewuoa-dev (>= 0.1.2),
- pkg-config,
+ pkgconf,
  libgsl-dev,
  libboost-dev,
  libboost-regex-dev,
+ libeigen3-dev,
  libclipper-dev,
  zlib1g-dev,
  libccp4-dev (>= 6.5.1-5)
@@ -44,9 +45,7 @@
 Architecture: any
 Depends:
  ${misc:Depends},
- ${shlibs:Depends},
- libcifpp5,
- libnewuoa0
+ ${shlibs:Depends}
 Description: Library file for libpdb-redo
  This library contains shared code for the various programs
  in the project PDB-REDO.
