## libpdb-redo 3.2.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(libpdb-redo VERSION 3.1.5 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.2.1 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
@@ -112,9 +112,12 @@
 	find_package(GSL REQUIRED)
 endif()
 
-if(NOT PDB_REDO_META)
+if(NOT (newuoa_FOUND OR TARGET newuoa))
 	find_package(newuoa REQUIRED)
-	find_package(cifpp 7.0.6 REQUIRED)
+endif()
+
+if(NOT (cifpp_FOUND OR TARGET cifpp))
+	find_package(cifpp 7.0.9 REQUIRED)
 endif()
 
 # Create a revision file, containing the current git version info
@@ -252,35 +255,8 @@
 	INPUT ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc.in)
 install(FILES ${CMAKE_CURRENT_BINARY_DIR}/libpdb-redo.pc DESTINATION ${CMAKE_INSTALL_LIBDIR}/pkgconfig)
 
-if(BUILD_TESTING AND NOT MSVC)
-	add_subdirectory(examples)
-
-	list(APPEND PDB_REDO_tests pdb-redo-unit)
-	if(BUILD_MINIMIZER)
-		list(APPEND PDB_REDO_tests rsr)
-	endif()
-
-	foreach(PDB_REDO_TEST IN LISTS PDB_REDO_tests)
-		set(PDB_REDO_TEST "${PDB_REDO_TEST}-test")
-		set(PDB_REDO_TEST_SOURCE "${PROJECT_SOURCE_DIR}/test/${PDB_REDO_TEST}.cpp")
-
-		add_executable(${PDB_REDO_TEST} ${PDB_REDO_TEST_SOURCE})
-		target_link_libraries(${PDB_REDO_TEST} PRIVATE pdb-redo)
-
-		if(MSVC)
-			# Specify unwind semantics so that MSVC knowns how to handle exceptions
-			target_compile_options(${PDB_REDO_TEST} PRIVATE /EHsc)
-		endif()
-
-		add_custom_target("run-${PDB_REDO_TEST}" DEPENDS ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch ${PDB_REDO_TEST})
-
-		add_custom_command(
-			OUTPUT ${CMAKE_CURRENT_BINARY_DIR}/Run${PDB_REDO_TEST}.touch
-			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
-
-		add_test(NAME ${PDB_REDO_TEST}
-			COMMAND $<TARGET_FILE:${PDB_REDO_TEST}> -- ${PROJECT_SOURCE_DIR}/test)
-	endforeach()
+if(BUILD_TESTING AND NOT MSVC AND PROJECT_IS_TOP_LEVEL)
+	add_subdirectory(test)
 endif()
 
 # Tarball generation
