=== debian/changelog ===
libpdb-redo (3.2.1-1) unstable; urgency=medium

  * New upstream version 3.2.1

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Tue, 28 Jan 2025 16:20:25 +0100
