=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
  debhelper-compat (= 13),
  libcifpp-dev (>= 7),
  cmake,
+ libcatch2-dev,
  libnewuoa-dev (>= 0.1.2),
  pkgconf,
  libgsl-dev,
